
/* This code is generated. Change template, not this */
#ifndef __HEADER_mpsys_parser
#define __HEADER_mpsys_parser

#include "mpsys.h"

#define DVB_MAX_SECTION_LENGTH 4096	/* EIT, otherwise 1024 */

typedef struct ts_program_association_st
{

	int transport_stream_id;

	int version_number;
	int current;
	int section_number;
	int last_section_number;

	int programs_count;
	struct ts_program_association_programs_st
	{

		int program_number;

		int pid;

	}
	programs[DVB_MAX_SECTION_LENGTH / 4];

}
ts_program_association;

int ts_program_association_parsable (buffer *);
char *ts_program_association_parsable_error (buffer *);
void ts_program_association_skip (buffer_iter *);
void ts_program_association_parse (ts_program_association *, buffer *);
void ts_program_association_print (ts_program_association *, FILE *);
void ts_program_association_parse_and_print (buffer *, FILE *);

typedef struct ts_conditional_access_st
{

	int version_number;
	int current;
	int section_number;
	int last_section_number;
	buffer_iter descriptors;

}
ts_conditional_access;

int ts_conditional_access_parsable (buffer *);
char *ts_conditional_access_parsable_error (buffer *);
void ts_conditional_access_skip (buffer_iter *);
void ts_conditional_access_parse (ts_conditional_access *, buffer *);
void ts_conditional_access_print (ts_conditional_access *, FILE *);
void ts_conditional_access_parse_and_print (buffer *, FILE *);

typedef struct ts_program_map_st
{

	int program_number;

	int version_number;
	int current;
	int section_number;
	int last_section_number;

	int pcr_pid;

	buffer_iter descriptors;

	int streams_count;
	struct ts_program_map_streams_st
	{

		int stream_type;

		int es_pid;

		buffer_iter descriptors;

	}
	streams[DVB_MAX_SECTION_LENGTH / 5];

}
ts_program_map;

int ts_program_map_parsable (buffer *);
char *ts_program_map_parsable_error (buffer *);
void ts_program_map_skip (buffer_iter *);
void ts_program_map_parse (ts_program_map *, buffer *);
void ts_program_map_print (ts_program_map *, FILE *);
void ts_program_map_parse_and_print (buffer *, FILE *);

typedef struct descriptor_video_st
{

	int multiple_frame_rate;
	int frame_rate_code;
	int mpeg_1_only;
	int constrained_parameter;
	int still_picture;

	int profile_and_level;
	int chroma_format;
	int frame_rate_extension;

}
descriptor_video;

int descriptor_video_parsable (buffer *);
char *descriptor_video_parsable_error (buffer *);
void descriptor_video_skip (buffer_iter *);
void descriptor_video_parse (descriptor_video *, buffer *);
void descriptor_video_print (descriptor_video *, FILE *);
void descriptor_video_parse_and_print (buffer *, FILE *);

typedef struct descriptor_audio_st
{

	int free_format_flag;
	int id;
	int layer;
	int variable_rate_audio;

}
descriptor_audio;

int descriptor_audio_parsable (buffer *);
char *descriptor_audio_parsable_error (buffer *);
void descriptor_audio_skip (buffer_iter *);
void descriptor_audio_parse (descriptor_audio *, buffer *);
void descriptor_audio_print (descriptor_audio *, FILE *);
void descriptor_audio_parse_and_print (buffer *, FILE *);

typedef struct descriptor_hierarchy_st
{

	int type;

	int layer_index;

	int embedded_layer_index;

	int channel;

}
descriptor_hierarchy;

int descriptor_hierarchy_parsable (buffer *);
char *descriptor_hierarchy_parsable_error (buffer *);
void descriptor_hierarchy_skip (buffer_iter *);
void descriptor_hierarchy_parse (descriptor_hierarchy *, buffer *);
void descriptor_hierarchy_print (descriptor_hierarchy *, FILE *);
void descriptor_hierarchy_parse_and_print (buffer *, FILE *);

typedef struct registration_st
{

	int identifier;
	buffer_iter info;

}
registration;

int registration_parsable (buffer *);
char *registration_parsable_error (buffer *);
void registration_skip (buffer_iter *);
void registration_parse (registration *, buffer *);
void registration_print (registration *, FILE *);
void registration_parse_and_print (buffer *, FILE *);

typedef struct data_alignment_st
{

	int alignment_type;

}
data_alignment;

int data_alignment_parsable (buffer *);
char *data_alignment_parsable_error (buffer *);
void data_alignment_skip (buffer_iter *);
void data_alignment_parse (data_alignment *, buffer *);
void data_alignment_print (data_alignment *, FILE *);
void data_alignment_parse_and_print (buffer *, FILE *);

typedef struct target_background_st
{

	int horizontal_size;
	int vertical_size;
	int aspect_ratio;

}
target_background;

int target_background_parsable (buffer *);
char *target_background_parsable_error (buffer *);
void target_background_skip (buffer_iter *);
void target_background_parse (target_background *, buffer *);
void target_background_print (target_background *, FILE *);
void target_background_parse_and_print (buffer *, FILE *);

typedef struct video_window_st
{

	int horizontal_offset;
	int vertical_offset;
	int window_priority;

}
video_window;

int video_window_parsable (buffer *);
char *video_window_parsable_error (buffer *);
void video_window_skip (buffer_iter *);
void video_window_parse (video_window *, buffer *);
void video_window_print (video_window *, FILE *);
void video_window_parse_and_print (buffer *, FILE *);

typedef struct conditional_access_st
{

	int system_id;

	int pid;
	buffer_iter data;

}
conditional_access;

int conditional_access_parsable (buffer *);
char *conditional_access_parsable_error (buffer *);
void conditional_access_skip (buffer_iter *);
void conditional_access_parse (conditional_access *, buffer *);
void conditional_access_print (conditional_access *, FILE *);
void conditional_access_parse_and_print (buffer *, FILE *);

typedef struct iso_language_st
{

	int language_code;
	int audio_type;

}
iso_language;

int iso_language_parsable (buffer *);
char *iso_language_parsable_error (buffer *);
void iso_language_skip (buffer_iter *);
void iso_language_parse (iso_language *, buffer *);
void iso_language_print (iso_language *, FILE *);
void iso_language_parse_and_print (buffer *, FILE *);

typedef struct system_clock_st
{

	int external_clock_reference;

	int accuracy_integer;
	int accuracy_exponent;

}
system_clock;

int system_clock_parsable (buffer *);
char *system_clock_parsable_error (buffer *);
void system_clock_skip (buffer_iter *);
void system_clock_parse (system_clock *, buffer *);
void system_clock_print (system_clock *, FILE *);
void system_clock_parse_and_print (buffer *, FILE *);

typedef struct multiplex_buffer_utilization_st
{

	int bound_valid;
	int ltw_offset_lower_bound;

	int ltw_offset_upper_bound;

}
multiplex_buffer_utilization;

int multiplex_buffer_utilization_parsable (buffer *);
char *multiplex_buffer_utilization_parsable_error (buffer *);
void multiplex_buffer_utilization_skip (buffer_iter *);
void multiplex_buffer_utilization_parse (multiplex_buffer_utilization *,
																				 buffer *);
void multiplex_buffer_utilization_print (multiplex_buffer_utilization *,
																				 FILE *);
void multiplex_buffer_utilization_parse_and_print (buffer *, FILE *);

typedef struct copyright_desc_st
{

	int identifier;
	buffer_iter info;

}
copyright_desc;

int copyright_desc_parsable (buffer *);
char *copyright_desc_parsable_error (buffer *);
void copyright_desc_skip (buffer_iter *);
void copyright_desc_parse (copyright_desc *, buffer *);
void copyright_desc_print (copyright_desc *, FILE *);
void copyright_desc_parse_and_print (buffer *, FILE *);

typedef struct maximum_bitrate_st
{

	int maximum_bitrate;

}
maximum_bitrate;

int maximum_bitrate_parsable (buffer *);
char *maximum_bitrate_parsable_error (buffer *);
void maximum_bitrate_skip (buffer_iter *);
void maximum_bitrate_parse (maximum_bitrate *, buffer *);
void maximum_bitrate_print (maximum_bitrate *, FILE *);
void maximum_bitrate_parse_and_print (buffer *, FILE *);

typedef struct private_data_desc_st
{

	int identifier;

}
private_data_desc;

int private_data_desc_parsable (buffer *);
char *private_data_desc_parsable_error (buffer *);
void private_data_desc_skip (buffer_iter *);
void private_data_desc_parse (private_data_desc *, buffer *);
void private_data_desc_print (private_data_desc *, FILE *);
void private_data_desc_parse_and_print (buffer *, FILE *);

typedef struct smoothing_buffer_st
{

	int sb_leak_rate;

	int sb_size;

}
smoothing_buffer;

int smoothing_buffer_parsable (buffer *);
char *smoothing_buffer_parsable_error (buffer *);
void smoothing_buffer_skip (buffer_iter *);
void smoothing_buffer_parse (smoothing_buffer *, buffer *);
void smoothing_buffer_print (smoothing_buffer *, FILE *);
void smoothing_buffer_parse_and_print (buffer *, FILE *);

typedef struct descriptor_std_st
{

	int leak_valid;

}
descriptor_std;

int descriptor_std_parsable (buffer *);
char *descriptor_std_parsable_error (buffer *);
void descriptor_std_skip (buffer_iter *);
void descriptor_std_parse (descriptor_std *, buffer *);
void descriptor_std_print (descriptor_std *, FILE *);
void descriptor_std_parse_and_print (buffer *, FILE *);

typedef struct descriptor_ibp_st
{

	int closed_gop;
	int identical_gop;
	int max_gop_length;

}
descriptor_ibp;

int descriptor_ibp_parsable (buffer *);
char *descriptor_ibp_parsable_error (buffer *);
void descriptor_ibp_skip (buffer_iter *);
void descriptor_ibp_parse (descriptor_ibp *, buffer *);
void descriptor_ibp_print (descriptor_ibp *, FILE *);
void descriptor_ibp_parse_and_print (buffer *, FILE *);

int ts_descriptor_parsable (buffer *);
void ts_descriptor_parse_and_print (buffer *, FILE *);
void ts_descriptor_loop_and_print (buffer_iter *, FILE *);

#endif
