#ifndef __HEADER_TS_CONFIG
#define __HEADER_TS_CONFIG

#include <stdio.h>

typedef struct config_st
{
	int verbose;
	
	int dump_pes;
	int dump_ts;
	int dump_es;
	int dump_info;
	
	int out_hex;
	int out_info_with_nit;

	enum config_out_enum { OUT_NONE, OUT_PES, OUT_ES, OUT_TS, OUT_INFO_XML, OUT_INFO_TEXT } out;
	
	int filter_audio;
	int filter_video;
	int filter_by_pid;
	int filtered_pid;
	
	FILE * fd_in;
	FILE * fd_out;
	char dev[64];
	
} config;

typedef struct _DEMULTIPLEXER_VALUE
{
    unsigned long   PID; 
    unsigned long   vPID;
	unsigned long   aPID;
	int             StreamType;	
	char            *FileName;
} DEMULTIPLEXER_VALUE, *P_DEMULTIPLEXER_VALUE;

#define	READ_ENABLE             _IOW(81, 30, P_DEMULTIPLEXER_VALUE)
#define TH_PID_TS_PACKET      0  
#define TH_PID_PES_PACKET     1  
#define TH_ALL_PID_TS_PACKET  3  
#define TH_VA_TS_PACKET       4  

void config_reset (config *cfg);
int config_parse (config *cfg, int argc, char **argv);
void dump_usage(void);

#endif
