#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <inttypes.h>
#include "read_demo.h"

#define DEV_NODE "/dev/twinhan0"
int main(int argc, char* argv[])
{  
    /****************** Init Device *********************/        
	PROGRAM_VALUE ProgramValue = 	    
	    //freq., Sym., QAM, vPid, aPid
		{593000, 6500, 64,  112,  114, 0,",,,",NULL,NULL};    
    
    CARD_VALUE cv;
    if (TH_ERROR == Getdevice_CardType(&cv))
	    return TH_ERROR;
	    
	if (TH_ERROR == Lock_Channel(&ProgramValue))
	    return TH_ERROR;
		
	SIGNAL_VALUE Signal_Val = {0, 0, 0};
	if (TH_ERROR == Getdevice_Signal_State(&Signal_Val))
	    return TH_ERROR;

	return  TH_NO_ERROR;
}
    
int Getdevice_Signal_State(P_SIGNAL_VALUE pSignal_Val)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }   
    
    if (ioctl(nDevHandle, DST_GET_SIGNAL, pSignal_Val)) {
        ERR_MSG("ioctl DST_GET_SIGNAL failed !\n");
        return TH_ERROR;
    }    
	
    DBG_MSG("Device signal: LockFlag=%d,  strength=%d,  quality=%d\n", 
             pSignal_Val->nLockFlag, pSignal_Val->nDevSigStrength, pSignal_Val->nDevSigQuality);
    close(nDevHandle);  
    return TH_NO_ERROR;
}

int Getdevice_CardType(P_CARD_VALUE pCV)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
        ERR_MSG("No device finded!\n");
        return TH_ERROR;
    }
    
    if (ioctl(nDevHandle, DST_GET_CARD_TYPE, pCV )) {
        ERR_MSG("ioctl DST_GET_CARD_TYPE failed !\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);     
    DBG_MSG("Card Name=%s,  TS_Size=%d !\n", pCV->sCard_Name, pCV->nTS_SIZE);
    return  TH_NO_ERROR;    
}

int Lock_Channel(P_PROGRAM_VALUE  pProgramValue)
{
    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
		ERR_MSG("No device finded!\n");
		return TH_ERROR;
	}
	
    if(ioctl(nDevHandle, TUNER_SETTUNER, pProgramValue ) ) {
        ERR_MSG("ioctl Set tuner failed !\n");
        return TH_ERROR;
    }
    if (ioctl(nDevHandle, DST_START_CAPTURE, 0 ) ) {
        ERR_MSG("ioctl start capture failed!\n");
        return TH_ERROR;
    }
    
    close(nDevHandle);        
    DBG_MSG("Lock channel OK!\n");
    return TH_NO_ERROR;
}

/*******************************************************************************/
