#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/fcntl.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <inttypes.h>
#include "read_demo.h"

#define DEV_NODE "/dev/twinhan0"

int main(int argc, char* argv[])
{                              
    DISEQC_COMMAND Dis_Comm3 = {0x03, 0xe0, 0x31, 0x66, 0x0, 0x0}; //BitCount, Frame, Address, Command
    DISEQC_COMMAND Dis_Comm4 = {0x04, 0xe0, 0x31, 0x68, 0x1, 0x0}; //BitCount, Frame, Address, Command, Data1
    DISEQC_COMMAND Dis_Comm5 = {0x05, 0xe0, 0x31, 0x6e, 0x1, 0x2}; //BitCount, Frame, Address, Command, Data1, Data2
    
    if (TH_ERROR == Setdevice_Diseqc_raw_command(&Dis_Comm3)) 
	    return TH_ERROR;
	    
    if (TH_ERROR == Setdevice_Diseqc_raw_command(&Dis_Comm4)) 
	    return TH_ERROR;
	    
	if (TH_ERROR == Setdevice_Diseqc_raw_command(&Dis_Comm5)) 
	    return TH_ERROR;    
	
	return  TH_NO_ERROR;
}
    
int Setdevice_Diseqc_raw_command(P_DISEQC_COMMAND pDis_Comm)
{
    unsigned char  result[8]=  {0x0, 0x0,  0x0,  0x0,  0x0,  0x0,  0x0, 0x0};

    int nDevHandle = open(DEV_NODE, O_RDONLY);
    if (nDevHandle < 0) {
		ERR_MSG("No device finded!\n");
		return TH_ERROR;
	}
	
	ioctl(nDevHandle, DST_SET_DISEQC_COMMAND, pDis_Comm);
    ioctl(nDevHandle, DST_GET_REPLY, &result);
	
	DBG_MSG("Setdevice_Diseqc_raw_command result=%02x, %02x, %02x, %02x, %02x, %02x, %02x, %02x \n", 
               result[0], result[1], result[2], result[3], result[4], result[5], result[6], result[7]);
	
	close(nDevHandle);    
    DBG_MSG("Setdevice_Diseqc_raw_command OK !\n");
    return TH_NO_ERROR;
}
/*******************************************************************************/
